'use strict';

var attr = require('./attr.js');
var set_style = require('./set_style.js');

function copyToClipboard(str) {
  var el = document.createElement('textarea');
  el.value = str;
  attr(el, 'readonly', '');
  set_style(el, 'position', 'absolute');
  set_style(el, 'left', '-9999px');
  document.body.appendChild(el);
  var selected = document.getSelection().rangeCount > 0 ? document.getSelection().getRangeAt(0) : false;
  el.select();
  document.execCommand('copy');
  document.body.removeChild(el);

  if (selected) {
    document.getSelection().removeAllRanges();
    document.getSelection().addRange(selected);
  }
}

module.exports = copyToClipboard;
