'use strict';

require('./get_tag.js');
var is_string = require('./is_string.js');
var is_nil = require('./is_nil.js');

/**
 * DeCapitalizes the first letter of a string.
 */

function coerceToString(value) {
  var defaultValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  if (is_nil(value)) {
    return defaultValue;
  }

  if (is_string(value)) {
    return value;
  }

  return String(value);
}

function deCapitalize(subject) {
  var subjectString = coerceToString(subject);

  if (subjectString === '') {
    return '';
  }

  return subjectString.substr(0, 1).toLowerCase() + subjectString.substr(1);
}

module.exports = deCapitalize;
