'use strict';

var is_object = require('./is_object.js');
require('./get_tag.js');
require('./is_array.js');
require('./is_string.js');
require('./is_map.js');
require('./is_set.js');
var is_empty = require('./is_empty.js');
var proper_object = require('./proper_object.js');

var deletedDiff = (lhs, rhs) => {
  if (lhs === rhs || !is_object(lhs) || !is_object(rhs)) return {};
  var l = proper_object(lhs);
  var r = proper_object(rhs);
  return Object.keys(l).reduce((acc, key) => {
    if (r.hasOwnProperty(key)) {
      var difference = deletedDiff(l[key], r[key]);
      if (is_object(difference) && is_empty(difference)) return acc;
      return { ...acc,
        [key]: difference
      };
    }

    return { ...acc,
      [key]: undefined
    };
  }, {});
};

module.exports = deletedDiff;
