/**
 * Copies the values of `source` to `array`.
 *
 * @private
 * @param {Array} source The array to copy values from.
 * @param {Array} [array=[]] The array to copy values to.
 * @returns {Array} Returns `array`.
 */
function copyArray(source, array) {
  var index = -1;
  var length = source.length; // eslint-disable-next-line no-param-reassign

  array || (array = new Array(length));

  while (++index < length) {
    array[index] = source[index];
  }

  return array;
}

export default copyArray;
