import isObject from './is_object.js';
import './get_tag.js';
import isFunction from './is_function.js';

function entries(obj) {
  if (!isObject(obj) && !isFunction(obj) || obj === null) {
    throw new Error('argument to `entries` must be an object');
  }

  var result = [];

  for (var key in obj) {
    if (obj.hasOwnProperty(key)) {
      result.push([key, obj[key]]);
    }
  }

  return result;
}

export default entries;
