import isObject from './is_object.js';
import './get_tag.js';
import isArray from './is_array.js';

/* eslint-disable eqeqeq */
function flush(collection) {
  var result;
  var len;
  var i;

  if (!collection) {
    return undefined;
  }

  if (isArray(collection)) {
    result = [];
    len = collection.length;

    for (i = 0; i < len; i++) {
      var elem = collection[i];

      if (elem != null) {
        result.push(elem);
      }
    }

    return result;
  }

  if (isObject(collection)) {
    result = {};
    var keys = Object.keys(collection);
    len = keys.length;

    for (i = 0; i < len; i++) {
      var key = keys[i];
      var value = collection[key];

      if (value != null) {
        result[key] = value;
      }
    }

    return result;
  }

  return undefined;
}

export default flush;
