import isObject from './is_object.js';
import './get_tag.js';
import isArray from './is_array.js';

function forEach(src, func) {
  var i = 0;

  if (isArray(src)) {
    while (i < src.length) {
      var rst = func(src[i], i, src);

      if (rst === false) {
        break;
      }

      i += 1;
    }
  } else if (isObject(src)) {
    var keys = Object.keys(src);

    while (i < keys.length) {
      var key = keys[i];

      var _rst = func(src[key], key, src);

      if (_rst === false) {
        break;
      }

      i += 1;
    }
  }
}

export default forEach;
