import isObject from './is_object.js';
import './get_tag.js';
import isArray from './is_array.js';

function map(src, func) {
  var rst = [];
  var i = 0;

  if (isArray(src)) {
    while (i < src.length) {
      rst.push(func(src[i], i, src));
      i += 1;
    }
  } else if (isObject(src)) {
    var keys = Object.keys(src);

    while (i < keys.length) {
      var key = keys[i];
      rst.push(func(src[key], key, src));
      i += 1;
    }
  }

  return rst;
}

export default map;
