/*
  returns a new object with the predicate applied to each value
  like map-object, but (value, key, object) are passed to the predicate
*/
function mapValues(obj, predicate) {
  var result = {};
  var keys = Object.keys(obj);
  var len = keys.length;

  for (var i = 0; i < len; i++) {
    var key = keys[i];
    result[key] = predicate(obj[key], key, obj);
  }

  return result;
}

export default mapValues;
