import isObject from './is_object.js';
import './get_tag.js';
import isArray from './is_array.js';
import isFunction from './is_function.js';

function values(obj) {
  var result = [];

  if (isArray(obj)) {
    return obj.slice(0);
  }

  if (isObject(obj) || isFunction(obj)) {
    var keys = Object.keys(obj);
    var len = keys.length;

    for (var i = 0; i < len; i++) {
      result.push(obj[keys[i]]);
    }

    return result;
  }

  throw new Error('argument to `values` must be an object');
}

export default values;
