'use strict';

var is_object = require('./is_object.js');
require('./get_tag.js');
var is_array = require('./is_array.js');

/* eslint-disable eqeqeq */
function flush(collection) {
  var result;
  var len;
  var i;

  if (!collection) {
    return undefined;
  }

  if (is_array(collection)) {
    result = [];
    len = collection.length;

    for (i = 0; i < len; i++) {
      var elem = collection[i];

      if (elem != null) {
        result.push(elem);
      }
    }

    return result;
  }

  if (is_object(collection)) {
    result = {};
    var keys = Object.keys(collection);
    len = keys.length;

    for (i = 0; i < len; i++) {
      var key = keys[i];
      var value = collection[key];

      if (value != null) {
        result[key] = value;
      }
    }

    return result;
  }

  return undefined;
}

module.exports = flush;
