'use strict';

var is_object = require('./is_object.js');
require('./get_tag.js');
var is_array = require('./is_array.js');

function forEach(src, func) {
  var i = 0;

  if (is_array(src)) {
    while (i < src.length) {
      var rst = func(src[i], i, src);

      if (rst === false) {
        break;
      }

      i += 1;
    }
  } else if (is_object(src)) {
    var keys = Object.keys(src);

    while (i < keys.length) {
      var key = keys[i];

      var _rst = func(src[key], key, src);

      if (_rst === false) {
        break;
      }

      i += 1;
    }
  }
}

module.exports = forEach;
