'use strict';

var is_object = require('./is_object.js');
require('./get_tag.js');
var is_array = require('./is_array.js');

function map(src, func) {
  var rst = [];
  var i = 0;

  if (is_array(src)) {
    while (i < src.length) {
      rst.push(func(src[i], i, src));
      i += 1;
    }
  } else if (is_object(src)) {
    var keys = Object.keys(src);

    while (i < keys.length) {
      var key = keys[i];
      rst.push(func(src[key], key, src));
      i += 1;
    }
  }

  return rst;
}

module.exports = map;
