'use strict';

require('./get_tag.js');
var is_array = require('./is_array.js');

var objectParam = arr => {
  var str = '';

  if (is_array(arr)) {
    str = arr.map(item => {
      return item.name + '=' + item.value;
    }).join('&');
  } else {
    str = objectParam(objectBigParam(arr));
  }

  return str;
};

var objectBigParam = obj => {
  var arr = [];
  Object.keys(obj).forEach(k => {
    if (is_array(obj[k])) {
      arr = arr.concat(obj[k].map(v => {
        return {
          name: k,
          value: v
        };
      }));
    } else {
      arr.push({
        name: k,
        value: obj[k]
      });
    }
  });
  return arr;
};

module.exports = objectParam;
