'use strict';

require('./get_tag.js');
var is_array = require('./is_array.js');
var is_number = require('./is_number.js');

function split(arr, n) {
  if (!is_array(arr)) {
    throw new Error('expected an array for the first argument');
  }

  if (n !== null && !is_number(n)) {
    throw new Error('expected a number or null for the second argument');
  } // eslint-disable-next-line no-param-reassign


  n = n !== null ? n : arr.length;
  var len = arr.length;
  var groups = [];

  for (var i = 0; i < len; i += n) {
    groups.push(arr.slice(i, i + n));
  }

  return groups;
}

module.exports = split;
