'use strict';

var is_object = require('./is_object.js');
require('./get_tag.js');
var is_array = require('./is_array.js');
var is_function = require('./is_function.js');

function values(obj) {
  var result = [];

  if (is_array(obj)) {
    return obj.slice(0);
  }

  if (is_object(obj) || is_function(obj)) {
    var keys = Object.keys(obj);
    var len = keys.length;

    for (var i = 0; i < len; i++) {
      result.push(obj[keys[i]]);
    }

    return result;
  }

  throw new Error('argument to `values` must be an object');
}

module.exports = values;
